#ifndef BISON_ACTIONS_HEADER
#define BISON_ACTIONS_HEADER

#include "../../backend/support/shared.h"

/**
 * Se definen las acciones a ejecutar sobre cada regla de producción de la
 * gramática. El objetivo de cada acción debe ser el de construir el nodo
 * adecuado que almacene la información requerida en el árbol de sintaxis
 * abstracta (i.e., el AST).
 */

// Programa.
int ProgramGrammarAction(const int value);

// Expresión.
int AdditionExpressionGrammarAction(const int leftValue, const int rightValue);
int SubtractionExpressionGrammarAction(const int leftValue, const int rightValue);
int MultiplicationExpressionGrammarAction(const int leftValue, const int rightValue);
int DivisionExpressionGrammarAction(const int leftValue, const int rightValue);
int FactorExpressionGrammarAction(const int value);

// Factores.
int ExpressionFactorGrammarAction(const int value);
int ConstantFactorGrammarAction(const int value);

// Constantes.
int IntegerConstantGrammarAction(const int value);
int DoubleConstantGrammarAction(const double value);

statement_t * EvaluateGrammarAction(evaluate_t * evaluate);
statement_t * IntegrateGrammarAction(integrate_t * integrate);
statement_t * DerivativeGrammarAction(derivative_t * derivative);
statement_t * IfGrammarAction(if_t * if_st);
statement_t * ForGrammarAction(for_t * for_st);
statement_t * WhileGrammarAction(while_t * while_st);
statement_t * PrintGrammarAction(print_t * print);
statement_t * DeclareVariableGrammarAction();
statement_t * AssignVariableGrammarAction();

#endif
